Sicuramente la prima da vedere è `button1`. Molto semplice, senza task/thread/niente.

Poi c'è `button2`, che prende la direzione dei task. Non è una direzione obbligata! Si potrebbe invece
"avanzare" sul fronte degli interrupt senza fare task separati.

`button3_int` mette insieme task e interrupt, introducendo anche le code (anche se in pratica le si usa come
fossero degli "Event").

`rotary` è concettualmente come `button3_int`, però trattandosi di encoder rotativi la logica dell'interrupt è
un pelo più complessa. Inoltre si usano le code per mandarsi dei messaggi "veri".

`serialpc` gestisce la porta seriale; per farlo utilizza una coda di trasmissione; la ricezione è invece
gestita "direttamente" perché i comandi sono semplici. C'è una printf embedded, una "malloc". L'invio dei
messaggi nelle code viene controllato (ci sono dei puntatori da controllare).

`ad9851` controlla il DDS ad9833 con bit-banging. c'è un po' di pulizia/modularizzazione del codice. La
libreria dovrebbe in teoria supportare anche ad9850 e ad9833, ma ancora non lo fa. Sarebbe il caso che il
supporto potesse essere modularizzato con delle define, in modo da poter compilare la libreria senza il codice
relativo ai dispositivi che non ci interessano.

`ssd1306` controlla lo schermo ssd1306, ma senza alcuna libreria grafica, quindi roba poco bella. La
"libreria" è organizzata in modo simile a quella dell'ad9833, quindi c'è un minimo di generalizzazione, usando
una struttura per memorizzare la configurazione dei pin. Implementato il setup(), manca ancora di
documentazione.


TODO:
`rotary_tbl`: prendendo http://makeatronics.blogspot.com/2013/02/efficiently-reading-quadrature-with.html per
implementare abbastanza facilmente tutti gli stati. c'è sia la versione con gli interrupt su entrambe le porte
che quella su una sola porta.

`ssd_menu`: usando la libreria uGui e ssd1306, implementiamo un semplice menu.
